# -*- coding: utf-8 -*-


import tensorflow as tf
import numpy as np
import random as rn
import sklearn.metrics as metrics
from sklearn.model_selection import KFold

num_folds = 10


#Dependencies


import keras
from keras.models import Sequential
from keras.layers import Dense
import pandas as pd
from sklearn.preprocessing import StandardScaler
from sklearn.preprocessing import OneHotEncoder
from sklearn.model_selection import train_test_split
from sklearn.metrics import accuracy_score


#dataset import
#se carga el archivo
dataset = pd.read_csv('nn3_predictors.csv', header=None) 
#dataset.head(10) #Return 10 rows of data

#removing rows with Nan values
dataset = dataset.dropna()


#Changing pandas dataframe to numpy array
X = dataset.iloc[:,:34].values
y = dataset.iloc[:,34:35].values


#Normalizing the data
sc = StandardScaler()
X = sc.fit_transform(X)


# Define per-fold score containers <-- these are new
acc_per_fold = []
loss_per_fold = []


# Merge inputs and targets
#Esto no ya que mis datos aun no están divididos en entrenamiento y prueba
"""
inputs = np.concatenate((input_train, input_test), axis=0)
targets = np.concatenate((target_train, target_test), axis=0)
"""

ohe = OneHotEncoder()
y = ohe.fit_transform(y).toarray()


# Define the K-fold Cross Validator
kfold = KFold(n_splits=num_folds, shuffle=True)

# K-fold Cross Validation model evaluation
fold_no = 1
for train, test in kfold.split(X, y):

	#Biulding the Neural Network

	# Neural network
	model = Sequential()

	#capa de entrada
	model.add(Dense(34, activation = 'relu', input_shape = (34,)))

	#ciclo para agregar capas ocultas
	capas = 8
	nodos = 20
	epocas = 200

	for i in range(capas):
		print "Agregando capa oculta con ", nodos," nodos"
		#capa oculta
		model.add(Dense(nodos	, activation = "relu"))

	#capa salida
	model.add(Dense(4, activation='softmax'))

	model.compile(loss='categorical_crossentropy', optimizer='adam', metrics=['accuracy'])

	# Generate a print
  	print '------------------------------------------------------------------------' 
	print 'Training for fold', fold_no, '...' 

	history = model.fit(X[train], y[train], epochs=epocas, shuffle=False, batch_size=64)


	# Generate generalization metrics
	scores = model.evaluate(X[test], y[test], verbose=0)
	print 'Score for fold ', fold_no, ' : ', model.metrics_names[0], ' of ', scores[0], ' ; ', model.metrics_names[1], 'of', scores[1]*100,'%'
	acc_per_fold.append(scores[1] * 100)
	loss_per_fold.append(scores[0])

	# Increase fold number
	fold_no = fold_no + 1


# == Provide average scores ==
print '------------------------------------------------------------------------' 
print 'Score per fold' 
for i in range(0, len(acc_per_fold)):
	print '------------------------------------------------------------------------' 
	print '> Fold', i+1, '- Loss:', loss_per_fold[i], ' Accuracy: ', acc_per_fold[i],'%' 
print '------------------------------------------------------------------------' 
print 'Average scores for all folds:' 
print '> Accuracy: ', np.mean(acc_per_fold), ' +- ', np.std(acc_per_fold)  
print '> Loss: ', np.mean(loss_per_fold)
print '------------------------------------------------------------------------'


